\ 430eforth-x-43n7vis : struct --> struct_2204.fs                     MM-220412
\ ------------------------------------------------------------------------------
\ MIT License (C) 2022 430eForth Workbench Project
\
\ Defining a named Data Structure in a VIS VOCabulary.
\
\ used:
   #require data-vocs
\ provided:
\  struct words 
\  end  begin

forth definitions decimal

voc struct  struct definitions

\ Begin a data structure definition in a VOCabulary.
: begin ( -- sys 0 ) 12345 0 ;

\ MM-220412
\ End a data structure definition in a VOCabulary. Create a constant u/i
\ with the actual data size. Abort if sys is unbalanced.
: end ( sys u -- )
  swap 12345 - abort"  sys?"
  pad aligned            \ $,n expects string in RAM to set the xtag
  $" u/i" over 4 cmove   \ RAM addr must be cell aligned 
  $,n overt [ ' bl @ ] literal , [ ' bl cell+ @ ] literal , , 
;

forth definitions

\\ Last Revision: MM-220412 end changed to secure cell aligned string address.

\ Application hints:

#require int

forth definitions

voc point  point definitions

struct begin
  int field: x
  int field: y
struct end

{ version 1     order:  forth  root  |  point 

: ! ( x y a0 -- ) dup >r @voc y !  r> @voc x ! ;

: @ ( a0 -- x y ) dup @voc x @  swap @voc y @ ;

: ? ( a0 -- ) dup @voc x ?  @voc y ? ;

forth definitions

} 

\ version 2     order:  point  forth  root  |  point 

@voc first

: ! ( x y a0 -- ) swap over y !  x ! ; 

: @ ( a0 -- x y ) dup x @ swap y @ ;

: ? ( a0 -- ) dup x ?  y ? ;

forth first

forth definitions

point item: Pt1     \ or   point field: Ptx   in a data structure

\  10 Pt1 x !    20 Pt1 y !   Pt1 x ?   Pt1 y ?   Pt1 ?

